Index: branches/src/ProcessManagement/ProcessManagement/Forms/Master/Security/FrmSecurityAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/Master/Security/FrmSecurityAuxiliary.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/Master/Security/FrmSecurityAuxiliary.cs	(revision 51)
@@ -0,0 +1,1077 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using System.Collections;
+using System.Diagnostics;
+using System.Threading;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+namespace ProcessManagement.Forms.Master
+{
+    partial class FrmSecurity
+    {
+        #region 列を作成する
+        /// <summary>
+        /// 列を作成する
+        /// </summary>
+        private int CreateCheckBoxColumn(string ColorText, int SecRank)
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+
+                DataGridViewCellStyle wrkCellStyle1 = new DataGridViewCellStyle();
+                DataGridViewCellStyle wrkCellStyle2 = new DataGridViewCellStyle();
+                DataGridViewCheckBoxColumn wrkColumn1 = new DataGridViewCheckBoxColumn();
+                DataGridViewCheckBoxColumn wrkColumn2 = new DataGridViewCheckBoxColumn();
+                m_CellStyle.Add(wrkCellStyle1);
+                m_CellStyle.Add(wrkCellStyle2);
+                m_CheckBox.Add(wrkColumn1);
+                m_CheckBox.Add(wrkColumn2);
+                // 
+                // wrkColumn1
+                // 
+                wrkCellStyle1.Alignment = System.Windows.Forms.DataGridViewContentAlignment.MiddleCenter;
+                wrkCellStyle1.BackColor = CommonMotions.getBackForeColor(ColorText, CommonDefine.PalceOfColor.BackColor);
+                wrkCellStyle1.ForeColor = System.Drawing.Color.Black;
+                wrkCellStyle1.NullValue = false;
+                wrkColumn1.DefaultCellStyle = wrkCellStyle1;
+                wrkColumn1.HeaderText = "処理起動";
+                wrkColumn1.HeaderCell.Style.Font = new System.Drawing.Font("ＭＳ 明朝", 9.5F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
+                wrkColumn1.Resizable = System.Windows.Forms.DataGridViewTriState.False;
+                wrkColumn1.Width = s_CheckCellWidth;
+                // 
+                // wrkColumn2
+                // 
+                wrkCellStyle2.Alignment = System.Windows.Forms.DataGridViewContentAlignment.MiddleCenter;
+                wrkCellStyle2.BackColor = CommonMotions.getBackForeColor(ColorText, CommonDefine.PalceOfColor.BackColor);
+                wrkCellStyle2.ForeColor = System.Drawing.Color.Black;
+                wrkCellStyle2.NullValue = false;
+                wrkColumn2.DefaultCellStyle = wrkCellStyle2;
+                wrkColumn2.HeaderText = "データ編集";
+                wrkColumn2.HeaderCell.Style.Font = new System.Drawing.Font("ＭＳ 明朝", 8F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
+                wrkColumn2.Resizable = System.Windows.Forms.DataGridViewTriState.False;
+                wrkColumn2.Width = s_CheckCellWidth;
+
+                dgv.Columns.Add(wrkColumn1);
+                dgv.Columns.Add(wrkColumn2);
+
+                int AddRowCnt = (dgv.ColumnCount - 2);
+
+                foreach (DataGridViewRow CurRow in dgv.Rows)
+                {
+                    CurRow.Cells[AddRowCnt].Value = false;
+                    CurRow.Cells[AddRowCnt + 1].Value = false;
+
+                }
+
+                // 特別権限は起動できたら編集できる
+                int SAccKey = (int)CommonDefine.SecurityRankPos.SpecialAuthority;   // 経営者アクセス
+                if (SecRank == CommonDefine.SecurityRankList[SAccKey].Key)
+                    dgv.Columns[dgv.ColumnCount - 1].ReadOnly = true;
+
+                return AddRowCnt;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return 0;
+            }
+        }
+        #endregion
+
+        #region カレントデータカウントを取得する
+        /// <summary>
+        /// カレントデータカウントを取得する
+        /// </summary>
+        /// <returns></returns>
+        private int CalcDataCount()
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+                DataGridViewCell CurCell = dgv.CurrentCell;
+                int DataColCnt = (CurCell.ColumnIndex - ((int)GridColumn.SecName + 1)) / (int)GridColumn.SecName;
+                if (DataColCnt < 0)
+                {
+                    MessageBox.Show("選択データがありません。", "選択確認", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return -1;
+                }
+
+                return DataColCnt;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return -1;
+            }
+        }
+        #endregion
+
+        #region 画面項目のチェック
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            bool bRet = true;
+            try
+            {
+
+                return bRet;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region セキュリティ区分マスタ登録
+        /// <summary>
+        /// セキュリティ区分マスタ登録
+        /// </summary>
+        private bool SecurityMasterDataEntry()
+        {
+            IOMSecurity secDB = new IOMSecurity();
+            IOMProcessExcute exeDB = new IOMProcessExcute();
+            try
+            {
+                DataGridView dgv = dgvProcess;
+
+                // ここではセキュリティ区分マスタの表示順だけを変更する
+                // 登録はFrmSecurityPersonの画面で登録時にデータ作成をおこなう
+
+                secDB.connect(); secDB.beginTran();
+                exeDB.connect(); exeDB.beginTran();
+
+                // 登録数を取得する
+                int DataColCnt = (dgv.ColumnCount - ((int)GridColumn.SecName + 1)) / (int)GridColumn.SecName;
+
+                // セキュリティ区分数だけ処理をおこなう
+                for (int i = 0; i < DataColCnt; i++)
+                {
+                    // セキュリティ区分マスタの表示順更新
+                    string strSQL = secDB.CreatePrimarykeyString(m_SecMasterList[i].SecCode);
+                    if (!secDB.UpdateFeild(m_SecMasterList[i].SecCode, (int)IOMSecurity.DataColumn.DisplayOrder, (i + 1), false))
+                    {
+                        secDB.rollback();
+                        exeDB.rollback();
+                        break;
+                    }
+
+                    // 区分の位置を求める
+                    int SelectCol = (i * (int)GridColumn.SecName) + ((int)GridColumn.SecName + 1);
+
+                    // まず削除する
+                    strSQL = exeDB.CreatePrimarykeyString(m_SecMasterList[i].SecCode);
+                    exeDB.DeleteAction(strSQL, false);
+
+                    foreach (DataGridViewRow CurRow in dgv.Rows)
+                    {
+                        // 処理番号取得
+                        int iSecCode = CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.SecCode].Value);
+
+                        // 起動指定無は処理しない
+                        bool bExecute = (bool)CurRow.Cells[SelectCol].Value;
+                        bool bEdit = (bool)CurRow.Cells[SelectCol + 1].Value;
+                        if (!bExecute && !bEdit) continue;
+
+                        // 起動対象マスタの登録
+                        ProcessExcute wrk = new ProcessExcute();
+                        // 保護区分番号
+                        wrk.SecCode = m_SecMasterList[i].SecCode;
+                        // 起動処理番号
+                        wrk.ExecCode = iSecCode;
+                        // 編集フラグ
+                        if (bEdit) wrk.EditFlg = (int)CommonDefine.ProcessDataEdit.Edit;
+                        // データ作成
+                        if (!exeDB.InsertAction(wrk, false))
+                        {
+                            secDB.rollback();
+                            exeDB.rollback();
+                            return false;
+                        }
+                    }
+                }
+
+                secDB.commit();
+                exeDB.commit();
+
+                // ログイン情報を書き換える
+                SetExecuteData4Login();
+                    
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                secDB.close(); secDB = null;
+                exeDB.close(); exeDB = null;
+            }
+        }
+        #endregion
+
+        #region ログインデータの起動許可参照を書き換える
+        /// <summary>
+        /// ログインデータの起動許可参照を書き換える
+        /// </summary>
+        /// <returns></returns>
+        private bool SetExecuteData4Login()
+        {
+            IOMProcessExcute execDB = new IOMProcessExcute();
+            try
+            {
+                // システム管理者は処理しない
+                if (CommonMotions.LoginUserData.PersonCode == CommonDefine.AdminCode) return true;
+                
+                // 起動データ取得
+                List<ProcessExcute> exeList = new List<ProcessExcute>();
+                string strExe = execDB.CreatePrimarykeyString(CommonMotions.LoginUserData.SecurityManagement) + " ORDER BY ExecCode";
+                if (!execDB.SelectAction(strExe, ref exeList)) return false;
+                CommonMotions.LoginUserProcExe.Clear();
+                foreach (ProcessExcute wrkRec in exeList)
+                {
+                    CommonMotions.LoginUserProcExe.Add(wrkRec);
+                }
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                execDB.close(); execDB = null;
+            }
+        }
+        #endregion
+
+        #region セキュリティ区分マスタ削除
+        /// <summary>
+        /// セキュリティ区分マスタ削除
+        /// </summary>
+        private bool SecurityMasterDataRemove()
+        {
+            IOMSecurity secDB = new IOMSecurity();
+            IOMProcessExcute exeDB = new IOMProcessExcute();
+            try
+            {
+                secDB.connect(); secDB.beginTran();
+                exeDB.connect(); exeDB.beginTran();
+
+                // データカウント取得
+                int DataColCnt = CalcDataCount();
+                if (DataColCnt < 0)
+                {
+                    return true;
+                }
+
+                string strSQL = secDB.CreatePrimarykeyString(m_SecMasterList[DataColCnt].SecCode);
+
+                if (!secDB.DeleteAction(strSQL, false))
+                {
+                    secDB.rollback();
+                    MessageBox.Show("セキュリティ区分マスタ削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                strSQL = exeDB.CreatePrimarykeyString(m_SecMasterList[DataColCnt].SecCode);
+                ProcessExcute ReadExeRec = new ProcessExcute();
+                if (exeDB.SelectAction(strSQL, ref ReadExeRec, false))
+                {
+                    if (!exeDB.DeleteAction(strSQL, false))
+                    {
+                        secDB.rollback();
+                        exeDB.rollback();
+                        MessageBox.Show("起動対象マスタ削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return false;
+                    }
+                }
+
+                secDB.commit();
+                exeDB.commit();
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                secDB.close(); secDB = null;
+                exeDB.close(); exeDB = null;
+            }
+        }
+        #endregion
+
+        #region データ読込順
+        /// <summary>
+        /// データ読込順
+        /// </summary>
+        private enum SelOrder
+        {
+            ExecCode = 0,
+            EditFlg,
+        }
+        #endregion
+
+        #region グリッドデータ表示
+        /// <summary>
+        /// グリッドデータ表示
+        /// </summary>
+        private bool DispSecurityGridData()
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+
+                // グリッドクリア
+                dgv.Rows.Clear();
+                for (int i = dgv.ColumnCount - 1; i > (int)GridColumn.SecName; i--)
+                {
+                    dgv.Columns.RemoveAt(i);
+                }
+
+                // 処理名追加
+                SetProcessGridData();
+
+                // データセット
+                SetProcessGridMasterData();
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 処理起動グリッド表示
+        /// <summary>
+        /// 処理起動グリッド表示
+        /// </summary>
+        private void SetProcessGridData()
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+                int icnt = 1;
+                
+                // ----- 起動処理一覧表示
+                foreach (KeyValuePair<int, string> wrkValue in ClsExcute.ProcessExecuteName)
+                {
+                    if (wrkValue.Key == 0) continue;
+//                    if (wrkValue.Key >= (int)ClsExcute.ProcessExecuteNo.Proceedings) break;   Del BIT 2017/02/22 
+                    int rcnt = dgv.Rows.Add(icnt++,
+                                            wrkValue.Key,
+                                            wrkValue.Value.Replace("－", ""),
+                                            true, true);
+                    dgv.Rows[rcnt].Cells[(int)GridColumn.SecName].Style.BackColor = s_DefaultColor[0];
+                }
+                
+                // ----- マスタメンテナンス一覧表示
+                foreach (KeyValuePair<int, string> wrkValue in ClsExcute.MaintenanceExecuteName)
+                {
+                    if (wrkValue.Key == 0) continue;
+                    int rcnt = dgv.Rows.Add(icnt++,
+                                            wrkValue.Key,
+                                            wrkValue.Value.Replace("－", ""),
+                                            true, true);
+                    dgv.Rows[rcnt].Cells[(int)GridColumn.SecName].Style.BackColor = s_DefaultColor[1];
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 処理起動グリッドへマスタデータのセット
+        /// <summary>
+        /// 処理起動グリッドへマスタデータのセット
+        /// </summary>
+        private void SetProcessGridMasterData()
+        {
+            IOMSecurity secDB = new IOMSecurity();
+            try
+            {
+                DataGridView dgv = dgvProcess;
+
+                // 起動対象マスタ取得
+                string strSQL = "SELECT";
+                strSQL += " A.*,";
+                strSQL += " B.EXECCODE,";
+                strSQL += " B.EDITFLG";
+                strSQL += " FROM SECURITYMASTER A";
+                strSQL += " LEFT JOIN PROCESSEXCUTEMASTER B ON B.SECCODE = A.SECCODE";
+                strSQL += " ORDER BY A.DISPLAYORDER, B.EXECCODE";
+                ArrayList peList = new ArrayList();
+                secDB.ExecuteReader(strSQL, ref peList);
+                if (peList.Count == 0) return;
+
+                m_SecMasterList.Clear();
+                int BreakSecCode = 0;
+                int Columncount = 0;
+                int ino = 0;
+                int SecDataCnt = Enum.GetNames(typeof(IOMSecurity.DataColumn)).Length;
+                foreach (object[] wrkobj in peList)
+                {
+                    // 保護区分マスタ取得
+                    SecurityMaster secRec = new SecurityMaster();
+                    secDB.Reader2Struct(wrkobj, ref secRec);
+
+                    if (BreakSecCode != secRec.SecCode)
+                    {
+                        // 内部マスタリスト作成
+                        m_SecMasterList.Add(secRec);
+                        // カラム作成
+                        Columncount = CreateCheckBoxColumn(secRec.SelectBackColor, secRec.SecRank);
+                        // コード退避
+                        BreakSecCode = secRec.SecCode;
+                    }
+                    // 編集のチェック
+                    ProcessExcute peRec = new ProcessExcute();
+                    peRec.ExecCode = CommonMotions.cnvInt(wrkobj[SecDataCnt + (int)SelOrder.ExecCode]);
+                    peRec.EditFlg = CommonMotions.cnvInt(wrkobj[SecDataCnt + (int)SelOrder.EditFlg]);
+
+                    foreach (DataGridViewRow CurRow in dgv.Rows)
+                    {
+                        // グリッドの処理番号を取得する
+                        int iSecCode = CommonMotions.cnvInt(CurRow.Cells[(int)GridColumn.SecCode].Value);
+                        // 起動対象マスタにデータが存在したらデータをセットする
+                        if (iSecCode == peRec.ExecCode)
+                        {
+                            // レコードがあれば起動にチェックする
+                            CurRow.Cells[Columncount].Value = true;
+                            // 編集可能ならばチェックする
+                            if (peRec.EditFlg == (int)CommonDefine.ProcessDataEdit.Edit)
+                            {
+                                CurRow.Cells[(Columncount + 1)].Value = true;
+                            }
+                            break;
+                        }
+                    }
+                    ino++;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                secDB.close(); secDB = null;
+            }
+        }
+        #endregion
+
+        #region 1列左移動処理
+        /// <summary>
+        /// 1列左移動処理
+        /// </summary>
+        public void GridColumnLeftAction()
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+                // 最前列は処理しない
+                if (dgv.CurrentCell.ColumnIndex <= ((int)GridColumn.SecName + 2)) return;
+
+                // カレント行数取得
+                int curRow = dgv.CurrentCell.RowIndex;
+                int curCol = dgv.CurrentCell.ColumnIndex;
+
+                // データ位置取得
+                int DataColCnt = CalcDataCount();
+                // カラム位置取得
+                int ColCnt = 0;
+                if ((curCol % 2) == 0)
+                {   // 偶数の場合は1つ前が前の列
+                    ColCnt = curCol - 1;
+                }
+                else
+                {   // 奇数の場合はそこが前の列
+                    ColCnt = curCol;
+                }
+
+                // カレント行退避
+                DataGridViewColumn currentcol1 = dgv.Columns[ColCnt];
+                DataGridViewColumn currentcol2 = dgv.Columns[ColCnt + 1];
+                
+                // １列前を退避
+                DataGridViewColumn frontcol1 = dgv.Columns[ColCnt - 2];
+                DataGridViewColumn frontcol2 = dgv.Columns[ColCnt - 1];
+
+                // 入れ替え
+                // カレント行→退避
+                int rowcnt = dgv.RowCount;
+
+                // カレント行退避
+                DataGridViewColumn SaveCol1 = new DataGridViewColumn();
+                DataGridViewColumn SaveCol2 = new DataGridViewColumn();
+                object[] SaveCol1Check = new object[dgv.RowCount];
+                object[] SaveCol2Check = new object[dgv.RowCount];
+
+                SaveCol1.DefaultCellStyle = currentcol1.DefaultCellStyle;
+                SaveCol1.HeaderText = currentcol1.HeaderText;
+                SaveCol2.DefaultCellStyle = currentcol2.DefaultCellStyle;
+                SaveCol2.HeaderText = currentcol2.HeaderText;
+                for (int i = 0; i < dgv.RowCount; i++)
+                {
+                    SaveCol1Check[i] = dgv[ColCnt, i].Value;
+                    SaveCol2Check[i] = dgv[ColCnt + 1, i].Value;
+                }
+
+                // 前行→カレント行
+                currentcol1.DefaultCellStyle = frontcol1.DefaultCellStyle;
+                currentcol1.HeaderText = frontcol1.HeaderText;
+                currentcol2.DefaultCellStyle = frontcol2.DefaultCellStyle;
+                currentcol2.HeaderText = frontcol2.HeaderText;
+                for (int i = 0; i < dgv.RowCount; i++)
+                {
+                    dgv[ColCnt, i].Value = dgv[ColCnt - 2, i].Value;
+                    dgv[ColCnt + 1, i].Value = dgv[ColCnt - 1, i].Value;
+                }
+
+                // カレント行→後行
+                frontcol1.DefaultCellStyle = SaveCol1.DefaultCellStyle;
+                frontcol1.HeaderText = SaveCol1.HeaderText;
+                frontcol2.DefaultCellStyle = SaveCol2.DefaultCellStyle;
+                frontcol2.HeaderText = SaveCol2.HeaderText;
+                for (int i = 0; i < dgv.RowCount; i++)
+                {
+                    dgv[ColCnt - 2, i].Value = SaveCol1Check[i];
+                    dgv[ColCnt - 1, i].Value = SaveCol2Check[i];
+                }
+
+                // マスタの配列を移動する
+                SecurityMaster wrkRec = m_SecMasterList[DataColCnt];
+                m_SecMasterList[DataColCnt] = m_SecMasterList[DataColCnt - 1];
+                m_SecMasterList[DataColCnt - 1] = wrkRec;
+
+                dgv.CurrentCell = dgv[curCol - 2, curRow];
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 1列右移動処理
+        /// <summary>
+        /// 1列右移動処理
+        /// </summary>
+        public void GridColumnRightAction()
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+                // 最前列は処理しない
+                if (dgv.CurrentCell.ColumnIndex > dgv.ColumnCount - 3) return;
+
+                // カレント行数取得
+                int curRow = dgv.CurrentCell.RowIndex;
+                int curCol = dgv.CurrentCell.ColumnIndex;
+
+                // データ位置取得
+                int DataColCnt = CalcDataCount();
+                // カラム位置取得
+                int ColCnt = 0;
+                if ((curCol % 2) == 0)
+                {   // 偶数の場合は1つ前が前の列
+                    ColCnt = curCol - 1;
+                }
+                else
+                {   // 奇数の場合はそこが前の列
+                    ColCnt = curCol;
+                }
+
+                // カレント行退避
+                DataGridViewColumn currentcol1 = dgv.Columns[ColCnt];
+                DataGridViewColumn currentcol2 = dgv.Columns[ColCnt + 1];
+
+                // １列後を退避
+                DataGridViewColumn rearcol1 = dgv.Columns[ColCnt + 2];
+                DataGridViewColumn rearcol2 = dgv.Columns[ColCnt + 3];
+
+                // 入れ替え
+                // カレント行→退避
+                int rowcnt = dgv.RowCount;
+
+                // カレント行退避
+                DataGridViewColumn SaveCol1 = new DataGridViewColumn();
+                DataGridViewColumn SaveCol2 = new DataGridViewColumn();
+                object[] SaveCol1Check = new object[dgv.RowCount];
+                object[] SaveCol2Check = new object[dgv.RowCount];
+
+                SaveCol1.DefaultCellStyle = currentcol1.DefaultCellStyle;
+                SaveCol1.HeaderText = currentcol1.HeaderText;
+                SaveCol2.DefaultCellStyle = currentcol2.DefaultCellStyle;
+                SaveCol2.HeaderText = currentcol2.HeaderText;
+                for (int i = 0; i < dgv.RowCount; i++)
+                {
+                    SaveCol1Check[i] = dgv[ColCnt, i].Value;
+                    SaveCol2Check[i] = dgv[ColCnt + 1, i].Value;
+                }
+
+                // 前行→カレント行
+                currentcol1.DefaultCellStyle = rearcol1.DefaultCellStyle;
+                currentcol1.HeaderText = rearcol1.HeaderText;
+                currentcol2.DefaultCellStyle = rearcol2.DefaultCellStyle;
+                currentcol2.HeaderText = rearcol2.HeaderText;
+                for (int i = 0; i < dgv.RowCount; i++)
+                {
+                    dgv[ColCnt, i].Value = dgv[ColCnt + 2, i].Value;
+                    dgv[ColCnt + 1, i].Value = dgv[ColCnt + 3, i].Value;
+                }
+
+                // カレント行→後行
+                rearcol1.DefaultCellStyle = SaveCol1.DefaultCellStyle;
+                rearcol1.HeaderText = SaveCol1.HeaderText;
+                rearcol2.DefaultCellStyle = SaveCol2.DefaultCellStyle;
+                rearcol2.HeaderText = SaveCol2.HeaderText;
+                for (int i = 0; i < dgv.RowCount; i++)
+                {
+                    dgv[ColCnt + 2, i].Value = SaveCol1Check[i];
+                    dgv[ColCnt + 3, i].Value = SaveCol2Check[i];
+                }
+
+                // マスタの配列を移動する
+                SecurityMaster wrkRec = m_SecMasterList[DataColCnt];
+                m_SecMasterList[DataColCnt] = m_SecMasterList[DataColCnt + 1];
+                m_SecMasterList[DataColCnt + 1] = wrkRec;
+
+                dgv.CurrentCell = dgv[curCol + 2, curRow];
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region セキュリティ区分使用チェック
+        /// <summary>
+        /// セキュリティ区分使用チェック
+        /// </summary>
+        /// <returns></returns>
+        private bool UseCheck()
+        {
+            IOMPersonInCharge PersonDB = new IOMPersonInCharge();
+            try
+            {
+                // カレントデータカウント取得
+                int DataColCnt = CalcDataCount();
+                if (DataColCnt < 0)
+                {
+                    return true;
+                }
+                int SecDiv = m_SecMasterList[DataColCnt].SecCode;
+                string strSQL = "SELECT COUNT(*) FROM PERSONINCHARGEMASTER";
+                strSQL += string.Format(" WHERE SECCODE = {0}", SecDiv);
+                ArrayList arList = new ArrayList();
+                if (!PersonDB.ExecuteReader(strSQL, ref arList)) return false;
+                object[] objwrk = (object[])arList[0];
+                if (CommonMotions.cnvInt(objwrk[0]) != 0) return false;
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                PersonDB.close(); PersonDB = null;
+            }
+        }
+        #endregion
+
+        #region 行デフォルト色
+        /// <summary>
+        /// 行をデフォルト色にする
+        /// </summary>
+        /// <param name="BeforeGridRow"></param>
+        private void DefaultRowChangeColor(int CurrentRowCnt)
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+                DataGridViewRow CurRow = dgv.Rows[CurrentRowCnt];
+                int colcnt = dgv.Columns.Count;
+                int RowCount = CurRow.Index;
+
+                Color SetBackColor = Color.White;
+                Color SetForeColor = Color.Black;
+
+                int ProcCode = CommonMotions.cnvInt(dgv.Rows[CurrentRowCnt].Cells[(int)GridColumn.SecCode].Value);
+                // 列の色を変える
+                for (int i = 0; i < colcnt; i++)
+                {
+                    switch (i)
+                    {
+                        case (int)GridColumn.SecName:
+                            if (ProcCode < (int)ClsExcute.MaintenanceExecuteNo.System)
+                                SetBackColor = s_DefaultColor[0];
+                            else
+                                SetBackColor = s_DefaultColor[1];
+                            break;
+                        default:
+                            if (CurrentRowCnt < (dgv.RowCount - 1))
+                            {   // 最終行以外は次行の色を取得する
+                                SetBackColor = dgv.Rows[CurrentRowCnt + 1].Cells[i].Style.BackColor;
+                            }
+                            else
+                            {   // 最終行は前行の色を取得する
+                                SetBackColor = dgv.Rows[CurrentRowCnt - 1].Cells[i].Style.BackColor;
+                            }
+                            break;
+                    }
+                    CurRow.Cells[i].Style.BackColor = SetBackColor;
+                    CurRow.Cells[i].Style.ForeColor = SetForeColor;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 行選択色
+        /// <summary>
+        /// 行を選択色にする
+        /// </summary>
+        /// <param name="CurrentRow"></param>
+        private void SelectRowChangeColor(int CurrentRow)
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+                DataGridViewRow CurRow = dgv.Rows[CurrentRow];
+                // カラム数
+                int colcnt = dgv.Columns.Count;
+
+                // 行の色を変える
+                for (int i = 0; i < colcnt; i++)
+                {
+                    dgv.Rows[m_BeforeGridRow].Cells[i].Style.BackColor = s_RowSelectColor;
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region カラムヘッダー標準の描画
+        /// <summary>
+        /// カラムヘッダー標準の描画
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        void GridCellPainting(object sender, DataGridViewCellPaintingEventArgs e)
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+                if (e.ColumnIndex < 0) return;
+                if (e.RowIndex != -1) return;
+
+                e.PaintBackground(e.CellBounds, false);
+                Rectangle r2 = e.CellBounds;
+                int HeadRowCnt = s_TitleRowCnt;
+
+                r2.Y += CommonMotions.cnvTruncate((e.CellBounds.Height / HeadRowCnt)) * (HeadRowCnt - 1);
+                r2.Height = e.CellBounds.Height / HeadRowCnt;
+                
+                e.PaintContent(r2);
+                Pen LinePen = new Pen(Color.Gray);
+                e.Graphics.DrawRectangle(LinePen, r2);
+                
+                e.Handled = true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 拡張カラムヘッダの描画
+        /// <summary>
+        /// 拡張カラムヘッダの描画
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void GridPaint(object sender, PaintEventArgs e)
+        {
+            try
+            {
+                // 先頭列のヘッダー描画
+                GridPaintColumn0(sender, e);
+
+                DataGridView dgv = dgvProcess;
+                int GridColumnCnt = dgv.ColumnCount;
+                int HeadRowCnt = s_TitleRowCnt;
+                Pen LinePen = new Pen(Color.Gray);
+                int Listno = 0;
+                for (int i = ((int)GridColumn.SecName + 1); i < GridColumnCnt; i += 2, Listno++)
+                {
+                    // カラムヘッダー取得
+                    Rectangle r1 = dgv.GetCellDisplayRectangle(i, -1, true);
+                    Rectangle r2 = dgv.GetCellDisplayRectangle((i + 1), -1, true);
+                    Rectangle rLine = dgv.GetCellDisplayRectangle(i, -1, true);
+
+                    r1.X += 1;
+                    r1.Y += 1;
+                    r1.Width = (r1.Width + r2.Width) - 2;
+
+                    r1.Height = r1.Height / HeadRowCnt - 2;
+                    e.Graphics.FillRectangle(new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.BackColor), r1);
+                    rLine.Width = rLine.Width * 2;
+                    rLine.Height = rLine.Height / HeadRowCnt;
+                    e.Graphics.DrawRectangle(LinePen, rLine);
+
+                    StringFormat format = new StringFormat();
+                    format.Alignment = StringAlignment.Center;
+                    format.LineAlignment = StringAlignment.Center;
+                    e.Graphics.DrawString(m_SecMasterList[Listno].SecName,
+                                            dgv.ColumnHeadersDefaultCellStyle.Font,
+                                            new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.ForeColor),
+                                            r1,
+                                            format);
+
+                    // 機密区分ランク
+                    KeyValuePair<int, string> SecRankValue;
+                    if (m_SecMasterList[Listno].SecRank == 0)
+                    {
+                        SecRankValue = CommonDefine.SecurityRankList[(int)CommonDefine.SecurityRankPos.NormalAuthority];
+                    }
+                    else
+                    {
+                        SecRankValue = CommonMotions.SearchSecurityRankList(m_SecMasterList[Listno].SecRank);
+                    }
+                    string ColumnHeaderStrings1 = SecRankValue.Value;
+
+                    rLine.Y += rLine.Height;
+                    e.Graphics.DrawRectangle(LinePen, rLine);
+
+                    r1.Y += (r1.Height + 2);
+                    e.Graphics.FillRectangle(new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.BackColor), r1);
+                    e.Graphics.DrawString(ColumnHeaderStrings1,
+                                            dgv.ColumnHeadersDefaultCellStyle.Font,
+                                            new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.ForeColor),
+                                            r1,
+                                            format);
+
+                    rLine.Y += rLine.Height;
+                    e.Graphics.DrawRectangle(LinePen, rLine);
+
+                    // 機密区分範囲
+                    KeyValuePair<int, string> SecRangeValue;
+                    if (m_SecMasterList[Listno].SecRange == 0)
+                    {
+                        SecRangeValue = CommonDefine.SecurityRangeList[(int)CommonDefine.SecurityRangePos.Only];
+                    }
+                    else
+                    {
+                        SecRangeValue = CommonMotions.SearchSecurityRangeList(m_SecMasterList[Listno].SecRange);
+                    }
+                    string ColumnHeaderStrings2 = SecRangeValue.Value;
+
+                    r1.Y += (r1.Height + 2);
+                    e.Graphics.FillRectangle(new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.BackColor), r1);
+                    e.Graphics.DrawString(ColumnHeaderStrings2,
+                                            dgv.ColumnHeadersDefaultCellStyle.Font,
+                                            new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.ForeColor),
+                                            r1,
+                                            format);
+
+                    rLine.Y += rLine.Height;
+                    e.Graphics.DrawRectangle(LinePen, rLine);
+
+                    // 総務業務範囲
+                    string ColumnHeaderStrings3 = CommonDefine.GeneralAffairsList[m_SecMasterList[Listno].GeneralAffairs].Value;
+
+                    r1.Y += (r1.Height + 2);
+                    e.Graphics.FillRectangle(new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.BackColor), r1);
+                    e.Graphics.DrawString(ColumnHeaderStrings3,
+                                            dgv.ColumnHeadersDefaultCellStyle.Font,
+                                            new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.ForeColor),
+                                            r1,
+                                            format);
+                }
+                
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region データグリッド先頭カラムの描画
+        /// <summary>
+        /// データグリッド先頭カラムの描画
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void GridPaintColumn0(object sender, PaintEventArgs e)
+        {
+            try
+            {
+                DataGridView dgv = dgvProcess;
+                int GridColumnCnt = dgv.ColumnCount;
+                int HeadRowCnt = s_TitleRowCnt;
+                Pen LinePen = new Pen(Color.Gray);
+
+                // カラムヘッダー取得
+                Rectangle r1 = dgv.GetCellDisplayRectangle((int)GridColumn.SecName, -1, true);
+                Rectangle r2 = dgv.GetCellDisplayRectangle((int)GridColumn.SecName, -1, true);
+                r1.X += 1;
+                r1.Y += 1;
+                r1.Height = r1.Height / HeadRowCnt - 2;
+                e.Graphics.FillRectangle(new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.BackColor), r1);
+                r2.Height = r2.Height / HeadRowCnt;
+                e.Graphics.DrawRectangle(LinePen, r2);
+
+                StringFormat format = new StringFormat();
+                format.Alignment = StringAlignment.Center;
+                format.LineAlignment = StringAlignment.Center;
+                e.Graphics.DrawString("セキュリティ区分名称",
+                                        dgv.ColumnHeadersDefaultCellStyle.Font,
+                                        new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.ForeColor),
+                                        r1,
+                                        format);
+
+                r2.Y += r2.Height;
+                e.Graphics.DrawRectangle(LinePen, r2);
+
+                r1.Y += (r1.Height + 2);
+                e.Graphics.FillRectangle(new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.BackColor), r1);
+                e.Graphics.DrawString("セキュリティ　区　分",
+                                        dgv.ColumnHeadersDefaultCellStyle.Font,
+                                        new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.ForeColor),
+                                        r1,
+                                        format);
+
+                r2.Y += r2.Height;
+                e.Graphics.DrawRectangle(LinePen, r2);
+
+                r1.Y += (r1.Height + 2);
+                e.Graphics.FillRectangle(new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.BackColor), r1);
+                e.Graphics.DrawString("セキュリティ　範　囲",
+                                        dgv.ColumnHeadersDefaultCellStyle.Font,
+                                        new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.ForeColor),
+                                        r1,
+                                        format);
+
+                r2.Y += r2.Height;
+                e.Graphics.DrawRectangle(LinePen, r2);
+
+                r1.Y += (r1.Height + 2);
+                e.Graphics.FillRectangle(new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.BackColor), r1);
+                e.Graphics.DrawString("総　務　業　務　実　行",
+                                        dgv.ColumnHeadersDefaultCellStyle.Font,
+                                        new SolidBrush(dgv.ColumnHeadersDefaultCellStyle.ForeColor),
+                                        r1,
+                                        format);
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 登録時にログイン者の内容をメモリへ取得する
+        /// <summary>
+        /// 登録時にログイン者の内容をメモリへ取得する
+        /// </summary>
+        private void SetMemTable()
+        {
+            IOMProcessExcute execDB = new IOMProcessExcute();
+            try
+            {
+                // システム管理者は処理しない
+                if (CommonMotions.LoginUserData.SecurityManagement == CommonDefine.AdminSecurityManagement) return;
+
+                CommonMotions.LoginUserProcExe.Clear();
+                // 起動データ取得
+                List<ProcessExcute> exeList = new List<ProcessExcute>();
+                string strExe = execDB.CreatePrimarykeyString(CommonMotions.LoginUserData.SecCode) + " ORDER BY EXECCODE";
+                execDB.SelectAction(strExe, ref exeList);
+                CommonMotions.LoginUserProcExe.Clear();
+                foreach (ProcessExcute wrkRec in exeList)
+                {
+                    CommonMotions.LoginUserProcExe.Add(wrkRec);
+                }
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                execDB.close(); execDB = null;
+            }
+        }
+        #endregion
+
+        #region 参照時ロック処理
+        /// <summary>
+        /// 参照時ロック処理
+        /// </summary>
+        private void ExecReadOnly()
+        {
+            try
+            {
+                dgvProcess.ReadOnly = true;
+
+                groupBox1.Visible = false;
+                groupBox2.Visible = false;
+                
+                btnDataEntry.Visible = false;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+    }
+}
